//------------------------------------------------------------------
#property copyright   "copyright mladen"
#property description "T3 PPO"
#property description "made by mladen"
#property description "for more visit www.forex-tsd.com"
#property link        "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1  clrSilver
#property indicator_color2  clrSilver
#property indicator_color3  clrLimeGreen
#property indicator_color4  clrOrangeRed
#property indicator_color5  clrDarkGray
#property indicator_color6  clrDarkGray
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  2
#property indicator_width5  2
#property indicator_width6  2
#property strict

extern int    LookBack  = 200;          // Look back period
extern double FastT3    = 20;           // Fast T3 period
extern double SlowT3    = 50;           // Slow T3 period
extern double HotT3     = 0.5;          // Hot for T3 calculations
extern bool   OriginalT3 = false;       // Calculate Tim tillson way of T3?
extern int    Price     = PRICE_MEDIAN; // Price
extern double Percent   = 90;           // Percent to use

double pctRankT[],pctRankB[],histnu[],histnd[],histd[],histu[],ppoT[],ppoB[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init() 
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,histnu); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,histnd); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,histu);  SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,histd);  SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,pctRankT);
   SetIndexBuffer(5,pctRankB);
   SetIndexBuffer(6,ppoT);
   SetIndexBuffer(7,ppoB);
      SetLevelValue(0, Percent/100);
      SetLevelValue(1,-Percent/100);
   return (0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         
   //
   //
   //
   //
   //

   for (int i=limit; i>=0; i--)   
   {
      double price = iMA(NULL,0,1,0,MODE_SMA,Price,i);
         double lmas = iT3(price,FastT3,HotT3,OriginalT3,i,0);
         double lmal = iT3(price,SlowT3,HotT3,OriginalT3,i,1);
            ppoT[i] = (lmas-lmal)/lmal*100.0;
            ppoB[i] = (lmal-lmas)/lmal*100.0;
            double topvalueMinus    = 0;
            double topvaluePlus     = 0;
            double bottomvalueMinus = 0;
            double bottomvaluePlus  = 0;
            for (int k = 0; k<LookBack && (i+k+1)<Bars; k++) 
            {
               if (ppoT[i+k+1]<ppoT[i]) 
                     topvalueMinus++;
               else  topvaluePlus++;
               if (ppoB[i+k+1]<ppoB[i]) 
                     bottomvalueMinus++;
               else  bottomvaluePlus++;
            }
            if (topvalueMinus+topvaluePlus!=0)       pctRankT[i] =   topvalueMinus   / (topvalueMinus+topvaluePlus);
            if (bottomvalueMinus+bottomvaluePlus!=0) pctRankB[i] = (bottomvalueMinus / (bottomvalueMinus+bottomvaluePlus)) *-1;
               histnd[i]   = EMPTY_VALUE;
               histnu[i]   = EMPTY_VALUE;
               histu[i]    = EMPTY_VALUE;
               histd[i]    = EMPTY_VALUE;
            if (pctRankT[i]> Percent/100)                       { histd[i]  = pctRankT[i]; histnd[i] = pctRankB[i]; }
            if (pctRankB[i]<-Percent/100)                       { histu[i]  = pctRankB[i]; histnu[i] = pctRankT[i]; }
            if (histd[i]==EMPTY_VALUE && histu[i]==EMPTY_VALUE) { histnd[i] = pctRankB[i]; histnu[i] = pctRankT[i]; }
   }
   return (0);   
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

#define t3Instances 2
double workT3[][t3Instances*6];
double workT3Coeffs[][6];
#define _tperiod 0
#define _c1      1
#define _c2      2
#define _c3      3
#define _c4      4
#define _alpha   5

//
//
//
//
//

double iT3(double price, double period, double hot, bool original, int i, int tinstanceNo=0)
{
   if (ArrayRange(workT3,0) != Bars)                 ArrayResize(workT3,Bars);
   if (ArrayRange(workT3Coeffs,0) < (tinstanceNo+1)) ArrayResize(workT3Coeffs,tinstanceNo+1);

   if (workT3Coeffs[tinstanceNo][_tperiod] != period)
   {
     workT3Coeffs[tinstanceNo][_tperiod] = period;
        double a = hot;
            workT3Coeffs[tinstanceNo][_c1] = -a*a*a;
            workT3Coeffs[tinstanceNo][_c2] = 3*a*a+3*a*a*a;
            workT3Coeffs[tinstanceNo][_c3] = -6*a*a-3*a-3*a*a*a;
            workT3Coeffs[tinstanceNo][_c4] = 1+3*a+a*a*a+3*a*a;
            if (original)
                 workT3Coeffs[tinstanceNo][_alpha] = 2.0/(1.0 + period);
            else workT3Coeffs[tinstanceNo][_alpha] = 2.0/(2.0 + (period-1.0)/2.0);
   }
   
   //
   //
   //
   //
   //
   
   int instanceNo = tinstanceNo*6;
   int r = Bars-i-1;
   if (r == 0)
      {
         workT3[r][0+instanceNo] = price;
         workT3[r][1+instanceNo] = price;
         workT3[r][2+instanceNo] = price;
         workT3[r][3+instanceNo] = price;
         workT3[r][4+instanceNo] = price;
         workT3[r][5+instanceNo] = price;
      }
   else
      {
         workT3[r][0+instanceNo] = workT3[r-1][0+instanceNo]+workT3Coeffs[tinstanceNo][_alpha]*(price                  -workT3[r-1][0+instanceNo]);
         workT3[r][1+instanceNo] = workT3[r-1][1+instanceNo]+workT3Coeffs[tinstanceNo][_alpha]*(workT3[r][0+instanceNo]-workT3[r-1][1+instanceNo]);
         workT3[r][2+instanceNo] = workT3[r-1][2+instanceNo]+workT3Coeffs[tinstanceNo][_alpha]*(workT3[r][1+instanceNo]-workT3[r-1][2+instanceNo]);
         workT3[r][3+instanceNo] = workT3[r-1][3+instanceNo]+workT3Coeffs[tinstanceNo][_alpha]*(workT3[r][2+instanceNo]-workT3[r-1][3+instanceNo]);
         workT3[r][4+instanceNo] = workT3[r-1][4+instanceNo]+workT3Coeffs[tinstanceNo][_alpha]*(workT3[r][3+instanceNo]-workT3[r-1][4+instanceNo]);
         workT3[r][5+instanceNo] = workT3[r-1][5+instanceNo]+workT3Coeffs[tinstanceNo][_alpha]*(workT3[r][4+instanceNo]-workT3[r-1][5+instanceNo]);
      }

   //
   //
   //
   //
   //
   
   return(workT3Coeffs[tinstanceNo][_c1]*workT3[r][5+instanceNo] + 
          workT3Coeffs[tinstanceNo][_c2]*workT3[r][4+instanceNo] + 
          workT3Coeffs[tinstanceNo][_c3]*workT3[r][3+instanceNo] + 
          workT3Coeffs[tinstanceNo][_c4]*workT3[r][2+instanceNo]);
}